#include <stdio.h>

#include "standard.h"

extern "C" WORD cpuid( void );
extern "C" WORD fpuid( void );
extern "C" WORD cpuspd( void );
WORD cpu_speed( WORD CPUTYPE );
WORD CPUID;
WORD FPUID;
BYTE *CPUTYPES[] = { "8086","80186","80286","80386","80486","Pentium" };
BYTE *FPUTYPES[] = { "None","8087","80287","80387" };

void main( void )
{
 CPUID = LOWBYTE(cpuid());
 FPUID = fpuid();

 if( NOT(FPUID) OR (CPUID EQU 4) OR (CPUID EQU 5) )
  printf( "%s-%u Mhz. CPU detected.\n",
	CPUTYPES[LOWBYTE(cpuid())],cpu_speed( LOWBYTE(cpuid()) ) );
 else
  printf( "%s/%s-%u Mhz. CPU/FPU detected.\n",
	CPUTYPES[LOWBYTE(cpuid())],FPUTYPES[FPUID],cpu_speed( LOWBYTE(cpuid()) ) );
}

WORD cpu_speed( WORD CPUTYPE )
{
 float y = 838.0965152;
 float o,x,r,t,c,REPS=800;

 switch( CPUTYPE )
  {
	case 0: //cpu=8086,5Mhz,144 clocks/div,800 opr.
	 t = 1000.00 / 5.00;
	 o = 144.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 5;
	 break;
	case 1:
	 t = 1000.00 / 8.00;
	 o = 22.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 8;
	 break;
	case 2:
	 t = 1000.00 / 12.00;
	 o = 22.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 12;
	 break;
	case 3:
	 t = 1000.00 / 16.00;
	 o = 22.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 16;
	 break;
	case 4:
	 t = 1000.00 / 33.00;
	 o = 24.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 33;
	 break;
	case 5:
	 t = 1000.00 / 66.00;
	 o = 25.00 * t;
	 x = o * REPS;
	 r = x/y;
	 c = (r/cpuspd()) * 66;
	 break;
	default:c=0;
  }
 return( (WORD)((WORD)((c+.50)*100)/100) );
}